## ros-foxy-mppic 0.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)
project(mppic CXX)

option(BUILD_SHARED_LIBS "Enable compilation of shared libraries" OFF)
option(ENABLE_TESTING "Enable Test Builds" ON)
option(ENABLE_CONAN "Use Conan for dependency management" ON)

include(cmake/StandardProjectSettings.cmake)
include(cmake/PreventInSourceBuilds.cmake)
include(cmake/CompilerWarnings.cmake)
include(cmake/Linker.cmake)
include(cmake/Sanitizers.cmake)
include(cmake/Doxygen.cmake)
include(cmake/StaticAnalyzers.cmake)
include(cmake/Conan.cmake)

if(ENABLE_CONAN)
  run_conan()
endif()

add_library(project_options INTERFACE)
target_include_directories(project_options INTERFACE include)
target_compile_features(project_options INTERFACE cxx_std_17)
target_compile_options(project_options INTERFACE -fconcepts)

target_link_libraries(project_options INTERFACE xtensor)
configure_linker(project_options)
enable_sanitizers(project_options)


find_package(ament_cmake REQUIRED)
find_package(nav2_common REQUIRED)
set(packages 
  rclcpp 
  pluginlib 
  tf2 
  geometry_msgs 
  visualization_msgs
  nav_msgs 
  nav2_core 
  nav2_costmap_2d 
  nav2_util
)

find_package(xtensor REQUIRED)

foreach(pkg IN LISTS packages)
  find_package(${pkg} REQUIRED)
endforeach()

add_subdirectory(src)
ament_export_libraries(mppic)
ament_export_dependencies(${packages})
ament_export_include_directories(include)
pluginlib_export_plugin_description_file(nav2_core mppic.xml)

if(ENABLE_TESTING)
  enable_testing()
  add_subdirectory(test)
endif()

install(TARGETS mppic
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(DIRECTORY include/
  DESTINATION include/
)

ament_package()

=== src/CMakeLists.txt ===
add_library(mppic SHARED Controller.cpp PathHandler.cpp)
ament_target_dependencies(mppic
  ${packages}
)

target_link_libraries(mppic project_options)

=== test/CMakeLists.txt ===
find_package(Catch2 REQUIRED)
include(Catch)

add_library(catch_main STATIC catch_main.cpp)
ament_target_dependencies(catch_main rclcpp)
target_link_libraries(catch_main Catch2::Catch2)

if (${DO_BENCHMARKS})
  target_compile_definitions(catch_main PUBLIC -DDO_BENCHMARKS)
endif()

if (${TEST_DEBUG_INFO})
  target_compile_definitions(catch_main PUBLIC -DTEST_DEBUG_INFO)
endif()

add_executable(optimizer-test optimizer-test.cpp)
ament_target_dependencies(optimizer-test ${packages})
target_link_libraries(optimizer-test catch_main project_options)
catch_discover_tests(optimizer-test)

add_executable(geometry-test geometry-test.cpp)
ament_target_dependencies(geometry-test ${packages})
target_link_libraries(geometry-test catch_main project_options)
catch_discover_tests(geometry-test)

=== debian/changelog ===
ros-foxy-mppic (0.2.1-2focal) focal; urgency=high

  * add functional tests
  * dev tools upgrade
  * fix control sequence propagation

 -- Aleksei Budyakov <budyakov.aleksei@gmail.com>  Mon, 04 Oct 2021 21:00:00 -0000

ros-foxy-mppic (0.2.0-2focal) focal; urgency=high

  * cost improvments
  * add documentation

 -- Aleksei Budyakov <budyakov.aleksei@gmail.com>  Fri, 01 Oct 2021 21:00:00 -0000

ros-foxy-mppic (0.1.0-2focal) focal; urgency=high

  * first release

 -- Aleksei Budyakov <budyakov.aleksei@gmail.com>  Sun, 29 Aug 2021 21:00:00 -0000

=== debian/control ===
Source: ros-foxy-mppic
Section: misc
Priority: optional
Maintainer: Aleksei Budyakov <budyakov.aleksei@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest, ros-foxy-geometry-msgs, ros-foxy-nav2-common, ros-foxy-nav2-core, ros-foxy-nav2-costmap-2d, ros-foxy-nav2-msgs, ros-foxy-nav2-util, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-tf2, ros-foxy-visualization-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-mppic
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-geometry-msgs, ros-foxy-nav2-bringup, ros-foxy-nav2-common, ros-foxy-nav2-core, ros-foxy-nav2-costmap-2d, ros-foxy-nav2-msgs, ros-foxy-nav2-util, ros-foxy-pluginlib, ros-foxy-rclcpp, ros-foxy-tf2, ros-foxy-visualization-msgs, ros-foxy-ros-workspace
Description: mppic

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-mppic//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
